#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

const int n = 14;

int U, T, g[n][n];

struct Solution
{
   string s, err_msg;
   int err_code;
   vector<int> seq;

   Solution(ifstream &f)
   {
      err_code = 0;
      f >> s;
      if (s == "YES") {
      	 while (1) {
      	    int t;
      	    f >> t;
      	    if (!f) break;
            if (t < 1 || t > n) {
               err_code = 1;
               err_msg = "illegal vertex in route";
            }
      	    seq.push_back(t);
      	 }
      } else if (s == "NO") {
         //still ok 
      } else {
         err_code = 2;
         return;
      }
   }

   int ok()
   {
      if (err_code) return 0;
      if (s == "NO") return 1;
      if (seq.size() < 2) {
         err_code = 1;
         err_msg = "answer length < 2";
         return 0;
      }
      if (seq[0] != U || seq[seq.size()-1] != U) {
         err_code = 1;
         err_msg = "answer start or end != U";
         return 0;
      }

      int cur_t = 0;
      int i;
      for (i = 0; i < seq.size()-1; i++) {
	 if (!g[seq[i]][seq[i+1]]) {
            err_code = 1;
            err_msg = "illegal edge";
            return 0;
	 }
	 cur_t += g[seq[i]][seq[i+1]];
      }
      if (cur_t != T) {
         err_code = 1;
         err_msg = "route time != T";
         return 0;
      }

      return 1;
   }
};

void botva(const char *msg)
{
   cout << msg;
}

int main(int argc, char* argv[])
{
   ifstream fin; ifstream fout; ifstream fans;
   fin.open(argv[1]); fout.open(argv[2]); fans.open(argv[3]);

   int i, m;
   fin >> m >> T >> U;
   for (i = 0; i < m; i++) {
      int ui, vi, ti;
      fin >> ui >> vi >> ti;
      g[ui][vi] = ti;
      g[vi][ui] = ti;
   }

   Solution contestant(fout);
   Solution jury(fans);

   if (contestant.s == jury.s && jury.s == "NO") {
      botva("ok");
      return 0;
   }

   if (!jury.ok()) {botva(("Bad jury solution: " + jury.err_msg).c_str()); return 3;}
   if (!contestant.ok()) {botva(contestant.err_msg.c_str()); return contestant.err_code;}

   if (contestant.s != jury.s) {
      if (contestant.s == "YES" && jury.s == "NO") {
         botva("jury didn't find solution, but contestant did");
         return 3;
      } else {
         botva("contestant didn't find solution");
         return 1;
      }
   }

   botva("ok");
   return 0;
}
